#define MIN_AMS 200
#include "extgraph.h"
#include "Edefs.h"

// Note: if DlgMessage wasn't buggy on AMS 1.xx, this program could be made
// compatible with all AMS versions:
// * MC_UNCHECK -> MC_FLIP.
// * VarOptList -> VarOptList hack for AMS 1.xx !
// Doesn't work, and useless anyway !
/*
#undef VarOptList
#define VarOptList \
((!AMS_1xx)?(unsigned short *const)_rom_call_addr(444) \
           :(unsigned short *const)(long)*(short *)((unsigned char*)_rom_call_addr(28C)+72))
// Nasty eh ?
*/



short init(unsigned char bricks[9][10]){
	short j=0,k=0,brks=0;
	for(j=0;j<10;j++)
	{
		for(k=0;k<9;k++)
		{
			if(bricks[k][j]!=0)brks++;
			Sprite16_RPLC_R(BX,BY,4,brick[bricks[k][j]], LCD_MEM);
		}
	}
	return(brks);
}

//Clean up and exit
__attribute__((noreturn))void Quit(HANDLE menu){
  //free menu memory and erase it
  MenuEnd(menu);
  char buff[9];
	//restore the key delays to their previous values
  OSInitBetweenKeyDelay(SBtwnDly);
  OSInitKeyInitDelay(SBforDly);
  //set the folder name that is
  //in the statiline to the curren
  //folder because we change it
  FolderGetCur(buff);
  ST_folder(buff);

  //partial HSR in c
  //we don't need to resotre
  //the statline or the line
  //abof it because we do not
  //draw anyting there
  WINDOW *window=FirstWindow;
  do{
  	//set the Dirty flag in all windows
		window->Flags|=WF_DIRTY;
		window=window->Next;
  }while(window!=NULL);
  //redraw Home Screen Menu
  MenuUpdate();
  ST_helpMsg("Jedit "VERSION_STR" by Jesse Frey");
  exit(0);
}

__attribute__((noreturn)) void _main(void)
{
	LEVEL open={1,{},""};
	HANDLE fileh;
	void *flptr;
	HSym hsFile;
	char buff[22];
  SYM_ENTRY *file;
	int j=0,k=0;
	unsigned char curent=1;
  unsigned short key=0,brks=0,lbrks=0;
  unsigned short size,Type=0;
  SET settings={35,50};
  //draw and set up the main toolbar menu
  HANDLE exec_handle = MenuBegin (&Main,0,0,0);
  //check one under the current toolbar because it is the default
  MenuCheck (exec_handle,C_ONE,MC_CHECK );
	//set the folder indicator to reflect the default curent brick
	ST_folder ("brick 1");
  //clear the middle section of the screen
	WinClr(DeskTop);
	//load settings from an external save file
  loadSet(&settings);
  //Show Open Save menue if they pressed esc quit
  switch(MenuPopup(&openSave,CENTER,CENTER,1)){
		case 0:
			Quit(exec_handle);
		case 2:
			//if the user chose new display the new dialog

			if(!(hsFile=new(&open,&Type)).folder){
				//if they pressed esc or there was an error exit
				Quit(exec_handle);
			}
		break;
		case 1:
			//if the user chose open show the open dialog
			if(!(hsFile=openFile(&open,&Type)).folder){
				//if they pressed esc or there was an error exit
				Quit(exec_handle);
			}
  }
	//we set the keybord repeat delays here incase the
	//APD turned off the calc during menu exicution
	SBtwnDly=OSInitBetweenKeyDelay(settings.BtwnDly);
  SBforDly=OSInitKeyInitDelay(settings.BforDly);
	//draw the bricks on the screen
	brks=init(open.bricks);
	//set the number of history pairs to reflect
	//the number of bricks on the screen out of 90
	ST_stack (brks,90);
	//set buisy status to idle
	ST_busy (ACTIVITY_IDLE);
	//Draw selector
	Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
	//main loop
  for(;;){
	//get key loop
		for(;;){
			//check for shift first because it does not
			//break if true
			if(_keytest(RR_SHIFT))
			{
					//set the number of bricks to the value that it should be
					if(curent!=0){
						if(open.bricks[k][j]==0)brks++;
					}else{
						if(open.bricks[k][j]!=0)brks--;
					}
					//put the brick in the aray
					open.bricks[k][j]=curent;
					//draw the brck on the screen
					Sprite16_RPLC_R(BX,BY,4,brick[open.bricks[k][j]], LCD_MEM);
					//if the number of bricks changed
					//update it on the statline
					if(lbrks!=brks){
						ST_stack (brks, 90);
			  		lbrks=brks;
			  	}
			  	//restart APD Timer
			  	OSTimerRestart(APD_TIMER);
			}
			//if we have a key use ngetchx to remove it
			if(kbhit()){
				//erase any help message
				ST_eraseHelp();
				//get the key we use ngetchx because it
				//seems to repeat better than OSdequeue
				key=ngetchx();
				//leave key loop so we can handle the key
				break;
			}
			//check if the APD Timer has expired
			if(OSTimerExpired(APD_TIMER)){
				off();
				//restart the APD timer
				OSTimerRestart(APD_TIMER);
				//we must set the key delays because
				//TIOS sets them to their defaults
				//when the calc is turned off
				OSInitBetweenKeyDelay(settings.BtwnDly);
  			OSInitKeyInitDelay(settings.BforDly);
			}
			//save power
			idle();
		}//end get key loop
		//key switch Mask out the high 4 bits because
		//they are set sometimes depending on the modkey state
  	switch(key&0x0FFF)
  	{
  		case KEY_ESC:
  			//ask if they want to save and save if they do
  			if(DlgMessage("Jedit "VERSION_STR,"Would you like to save the changes",BT_YES,BT_NO)==KEY_ENTER){
					save(hsFile,&open,Type);
				}
				Quit(exec_handle);
  		case 'x':
  		case 'X':
  			//set the current brick to brick one and uncheck
  			//the old curent brick and check the new one
  			//for some reison it also draws that brick where
  			//the selector happens to be
  			MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  			MenuCheck (exec_handle, C_ONE, MC_CHECK);
  			curent=1;
  			ST_folder ("brick 1");
  		break;
  		case 'y':
  		case 'Y':
   			//set the current brick to brick two and uncheck
  			//the old curent brick and check the new one
  			//for some reison it also draws that brick where
  			//the selector happens to be
  			MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  			MenuCheck (exec_handle, C_TWO, MC_CHECK);
  			curent=2;
  			ST_folder ("brick 2");
  		break;
  		case 'z':
  		case 'Z':
  			//set the current brick to brick three and uncheck
  			//the old curent brick and check the new one
  			//for some reison it also draws that brick where
  			//the selector happens to be
  			MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  			MenuCheck (exec_handle, C_THREE, MC_CHECK);
  			curent=3;
  			ST_folder ("brick 3");
  		break;
  		case 't':
  		case 'T':
  			//set the current brick to brick four and uncheck
  			//the old curent brick and check the new one
  			//for some reison it also draws that brick where
  			//the selector happens to be
  			MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  			MenuCheck (exec_handle, C_FOUR, MC_CHECK);
  			curent=4;
  			ST_folder ("brick 4");
  		break;
  		case '^':
  		case 140:
  			//set the current brick to brick no brikc and uncheck
  			//the old curent brick and check the new one
  			//for some reison it also draws that brick where
  			//the selector happens to be
  			MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  			MenuCheck (exec_handle, C_NONE, MC_CHECK);
  			curent=0;
  			ST_folder ("no brick");
  		break;
			case KEY_CLEAR:
				//sets all bricks to zero then redraws them
				memset(open.bricks,0,90);
				brks=init(open.bricks);
			break;
			case KEY_BACKSPACE:
				//delets the brick at the selector positon
				if(open.bricks[k][j]!=0)brks--;
	 			open.bricks[k][j]=0;
	 			Sprite16_RPLC_R(BX,BY,4,brick[0], LCD_MEM);
			break;
			case KEY_DOWNRIGHT:
				//move the selector down and right
				if(k<8 && j<9)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					k++;
					j++;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_RIGHT:
			//move the selector right
				if(k<8)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					k++;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_UPRIGHT:
			//move the selector up and right
				if(j>0 && k<8)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					j--;
					k++;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_UP:
			//move the selector up
				if(j>0)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					j--;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_UPLEFT:
			//move the selector up and left
				if(k>0 && j>0)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					k--;
					j--;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_LEFT:
			//move the selector left
				if(k>0)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					k--;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_DOWNLEFT:
			//move the selector down and left
				if(j<9 && k>0)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					j++;
					k--;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_DOWN:
			//move the selector down
				if(j<9)
				{
					Sprite32_AND_R(SX,SY,6,remov,LCD_MEM);
					j++;
					Sprite32_OR_R(SX,SY,6,select,LCD_MEM);
				}
			break;
			case KEY_ON:
			//dont turn off if just the on key is pressed
				if(!(key&0xF000))break;
				off();
				//we must set the key delays because
				//TIOS sets them to their defaults
				//when the calc is turned off
				OSInitBetweenKeyDelay (settings.BtwnDly);
  			OSInitKeyInitDelay (settings.BforDly);
			break;
  		default:
  			//menu switch pass key to the menu
  			//MenuKey takes care of drawing menues
  			//if they need to apere
  			switch(MenuKey(exec_handle,key))
  			{
  			#ifndef SMALL
  				case HELP:
  				//show help dialog
						DlgMessage("Jedit "VERSION_STR" Help",
						"Use the arrows to move the selector"
						"around the screan. When it is where you want"
						"press mode to place the current brick there."
						"when you have finished placing all the"
						"bricks that you want, choose save from the "
						"File menue. A save dialog will pop up choose"
						"the options that you want and pres ok to save.",BT_OK,BT_NONE);
  				break;
					case KEYS:
					//show keys dialog
						DlgMessage("Keys","[esc] Exit\n"
						"[clear] Clear the level\n"
						"[<-] delete brick\n"
						"[x] set brick to 1\n"
						"[y] set brick to 2\n"
						"[z] set brick to 3\n"
						"[t] set brick to 4\n"
						"[^] set brick to no brick\n"
						"[shift] place brick\n"
						"[arrows] move selector",BT_OK,BT_NONE);
					break;
				#endif
  				case C_NONE:
  				  //set the current brick to no brick and uncheck
		  			//the old curent brick and check the new one
  					MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  					MenuCheck (exec_handle, 8, MC_CHECK);
  					curent=0;
  					ST_folder ("no brick");
  				break;
  				case C_ONE:
  				 //set the current brick to brick one and uncheck
		  			//the old curent brick and check the new one
  					MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  					MenuCheck (exec_handle, 9, MC_CHECK);
  					curent=1;
  					ST_folder ("brick 1");
  				break;
  				case C_TWO:
  				 //set the current brick to brick two and uncheck
		  			//the old curent brick and check the new one
  				 	MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  					MenuCheck (exec_handle, 10, MC_CHECK);
  					curent=2;
  					ST_folder ("brick 2");
  				break;
  				case C_THREE:
  				 //set the current brick to brick three and uncheck
		  			//the old curent brick and check the new one
  				 	MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  					MenuCheck (exec_handle, 11, MC_CHECK);
  					curent=3;
  					ST_folder ("brick 3");
  				break;
  				case C_FOUR:
  				 //set the current brick to brick four and uncheck
		  			//the old curent brick and check the new one
  				 	MenuCheck (exec_handle, C_NONE+curent, MC_FLIP);
  					MenuCheck (exec_handle, 12, MC_CHECK);
  					curent=4;
  					ST_folder ("brick 4");
  				break;
  				case NEW:
					{
						//save old hsFile so if they pressed esc it can be restored
  					if(DlgMessage("Jedit "VERSION_STR,"Would you like to save the changes",BT_YES,BT_NO)==KEY_ENTER){
							save(hsFile,&open,Type);
						}
  					HSym hsTfile=hsFile;
  					if(!(hsFile=new(&open,&Type)).folder){
							hsFile=hsTfile;
						}
						brks=init(open.bricks);
						ST_stack (brks,90);
					}
  				break;
  				case OPEN:
					  {
					  	//save old hsFile so if they pressed esc it can be restored
							HSym hsTfile=hsFile;
							if(DlgMessage("Jedit "VERSION_STR,"Would you like to save the changes",BT_YES,BT_NO)==KEY_ENTER){
								save(hsFile,&open,Type);
							}
							if(!(hsFile=openFile(&open,&Type)).folder){
								hsFile=hsTfile;
							}
							//draw bricks
							brks=init(open.bricks);
							ST_stack (brks,90);
					  }
  				break;
  				case SAVE:
  					//try to save level
						if(save(hsFile,&open,Type)){
							ST_helpMsg("level Saved");
						}else{
							ST_helpMsg("out of Memory!");
						}
  				break;
  				case SAVE_AS:
						if(Type!=3){
		  				if(!(hsFile=VarSaveAs(tags+1,NULL,exts)).folder)break;
								Type=*VarOptList;
								fileh=HeapAlloc(100+(Type==1));
								if(!(file=DerefSym(hsFile)))Quit(exec_handle);
								file->handle=fileh;
								flptr=HeapDeref(fileh);
								*(short*)flptr=98+(Type==1);
								memcpy(flptr+2,&open,92);
								memcpy(flptr+94,fltgs[(Type-1)],6+(Type==1));
						}else{
							HSym hsTfile;
							if(!(fileh=HeapAlloc(*(unsigned short*)(HeapDeref(DerefSym(hsFile)->handle))+2))){
								ST_helpMsg("out of Memory!");
								break;
							}
							if((hsTfile=VarSaveAs(tags+2,NULL,exts+2)).folder){
								DerefSym(hsTfile)->handle=fileh;
								flptr=HeapDeref(DerefSym(hsFile)->handle);
								memcpy(HeapDeref(fileh),flptr,(*(unsigned short*)flptr)+2);
								memcpy(HeapDeref(fileh)+4+90*open.ll,open.bricks,92);
								ST_helpMsg("level Saved");
							}else{
								HeapFree(fileh);
							}
						}
  				break;
  				case EDIT_N:
  				//edit the next level
  					if(Type==3){
  						//if we are dealing whith a level set then
  						//we have to read the next level from the file
							if(DlgMessage("Jedit "VERSION_STR,"Would you like to save the changes",BT_YES,BT_NO)==KEY_ENTER){
								save(hsFile,&open,Type);
							}
							fileh=DerefSym(hsFile)->handle;
  						flptr=HeapDeref(fileh);
							open.ll++;
  						if(*(unsigned short*)(flptr+2)<open.ll+1)open.ll=0;
  						memcpy(open.bricks,flptr+4+90*(open.ll),90);
  						brks=init(open.bricks);
							ST_stack (brks,90);
  					}else{
  						//if we are dealing whith a single level
  						//then edit the name of the next level
							SymCpy0(buff,open.nlevel);
  						if(Dialog(&NextLevel,CENTER,CENTER,buff,NULL)==KEY_ENTER){
  							fileh=DerefSym(hsFile)->handle;
  							if(!buff[0]){
									open.ll=TRUE;
  								if(Type==1){
  									size=101;
  								}else{
  									size=100;
  								}
  								HeapRealloc(fileh,size);
									break;
  							}
  							ESI temp=TokenizeSymName(buff,0);
  							if(!temp){
  								open.ll=TRUE;
  								if(Type==1){
  									size=101;
  								}else{
  									size=100;
  								}
  								HeapRealloc(fileh,size);
									ST_helpMsg("Bad Name!");
									break;
  							}
  							open.ll=FALSE;
  							top_estack=temp;
  							SymCpy0(open.nlevel,buff);
  							 if(Type==1){
  									size=110;
  								}else{
  									size=109;
  								}
								if(!HeapRealloc(fileh,size)){
									ST_helpMsg("out of Memory!");
									open.ll=TRUE;
								}
  						}
  					}
  				break;
  				case PREFS:
						sprintf(&buff[10],"%i",settings.BtwnDly);
						sprintf(buff,"%i",settings.BforDly);
	  				if(Dialog(&Prefs,CENTER,CENTER,buff,NULL)==KEY_ENTER)
						{
							settings.BforDly=atoi(buff);
							OSInitKeyInitDelay(settings.BforDly);
							settings.BtwnDly=atoi(&buff[10]);
							OSInitBetweenKeyDelay(settings.BtwnDly);
							saveSet(&settings);
						}
  				break;
  				case QUIT:
		  			if(DlgMessage("Jedit "VERSION_STR,"Would you like to save the changes",BT_YES,BT_NO)==KEY_ENTER){
							save(hsFile,&open,Type);
						}
  					Quit(exec_handle);
  				break;
  			#ifndef SMALL
  				case ABOUT:
  				//about dialog
  					DlgMessage(EXTGRAPH_VERSION_PWDSTR,"About Jedit "VERSION_STR":\n"
  					"By Jesse Frey\n"
  					"Compiled whith:\n"
  					__TIGCC_VERSION_STRING__,BT_OK,BT_NONE);
  				break;
  			#endif
  				case F_ONE:
  				//fill whith brick one
						memset(open.bricks,1,90);
						brks=init(open.bricks);
  				break;
  				case F_TWO:
					//fill whith brick two
						memset(open.bricks,2,90);
						brks=init(open.bricks);
  				break;
  				case F_THREE:
  				//fill whith brick three
						memset(open.bricks,3,90);
						brks=init(open.bricks);
  				break;
  				case F_FOUR:
  				//fill whith brick four
						memset(open.bricks,4,90);
						brks=init(open.bricks);
  				break;
  				case FILL_CURRENT:
  				//fill whith the curent brick
  					memset(open.bricks,curent,90);
						brks=init(open.bricks);
  			}//end menue switch
  			ST_busy (ACTIVITY_IDLE);
  	}//end main switch
  	if(lbrks!=brks){
			ST_stack (brks, 90);
  		lbrks=brks;
  	}
  }
}

//=================Open Save popup=====================
asm("
.text
.data
openSave:\n"
"        .word  title_text - openSave\n"
"        .word  0xD5\n"
"        .word  9\n"
"        .byte  0, 58\n"
"        .word  5\n"
"        .word  0\n"
"        .word  0\n"
"        .word  0\n"
"        .long  -1\n"
"      main_entries:\n"
"        .word  MT_TEXT + 1\n"
"        .word  text1 - title_text\n"
"        .word  MT_TEXT + 2\n"
"        .word  text2 - title_text\n"
"        .long  -1\n"
"      title_text:\n"
"        .asciz \"Jedit "VERSION_STR"\"\n"
"      text1:\n"
"        .asciz \"Open\"\n"
"      text2:\n"
"        .asciz \"New\"\n");
//======================main menu===========================
#ifdef USE_TI89
asm("|created whith ti flash studio and coppied here
|main menue
.text

	.even
Main:	.word (_Main_0-Main)
	.word 2
	.word 18
	.byte 240,18
	.word 6
	.word 0
	.word 0,0
	.long 0xFFFFFFFF
	.long 0xCFFF0000 + ((_Main_4095 - _Main_0))
	.word (__Main_1 - Main)\n"
#ifndef SMALL
	".long 0xCFFE0000 + ((_Main_4094 - _Main_0))
	.word (__Main_5 - Main)\n"
#endif
	".long 0xCFFD0000 + ((_Main_4093 - _Main_0))
	.word (__Main_8 - Main)
	.long 0xCFFC0000 + ((_Main_4092-_Main_0))
	.word (__Main_14 - Main)
	.long 0x80140000 + ((_Main_18 - _Main_0))
	.long 0xFFFFFFFF
__Main_1:
	.long 0x80010000 + ((_Main_14-_Main_0))
	.long 0x80020000 + ((_Main_1-_Main_0))
	.long 0x80030000 + ((_Main_2-_Main_0))
	.long 0x80040000 + ((_Main_13-_Main_0))
	.long 0x80050000 + ((_Main_15-_Main_0))
	.long 0x80060000 + ((_Main_3-_Main_0))
	.long 0x80070000 + ((_Main_4-_Main_0))
	.long 0xFFFFFFFF\n"
#ifndef SMALL
"__Main_5:
	.long 0x80080000 + ((_Main_5-_Main_0))
	.long 0x80090000 + ((_Main_6-_Main_0))
	.long 0x800A0000 + ((_Main_7-_Main_0))
	.long 0xFFFFFFFF\n"
#endif
"__Main_8:
	.long 0x800B0000 + ((_Main_8-_Main_0))
	.long 0x800C0000 + ((_Main_9-_Main_0))
	.long 0x800D0000 + ((_Main_10-_Main_0))
	.long 0x800E0000 + ((_Main_11-_Main_0))
	.long 0x800F0000 + ((_Main_12-_Main_0))
	.long 0xFFFFFFFF
__Main_14:
	.long 0x80100000 + ((_Main_9-_Main_0))
	.long 0x80110000 + ((_Main_10-_Main_0))
	.long 0x80120000 + ((_Main_11-_Main_0))
	.long 0x80130000 + ((_Main_12-_Main_0))
	.long 0xFFFFFFFF
_Main_0:
_Main_4095:	.byte 0x20,0x20,0x46,0x69,0x6C,0x65,0x20,0x20,0
_Main_1:	.byte 0x4F,0x70,0x65,0x6E,0
_Main_2:	.byte 0x53,0x61,0x76,0x65,0
_Main_3:	.byte 0x50,0x72,0x65,0x66,0x73,0
_Main_4:	.byte 0x51,0x75,0x69,0x74,0\n"
#ifndef SMALL
"_Main_4094:	.byte 0x20,0x20,0x48,0x65,0x6C,0x70,0x20,0x20,0
_Main_5:	.byte 0x4B,0x65,0x79,0x73,0
_Main_6:	.byte 0x68,0x65,0x6C,0x70,0
_Main_7:	.byte 0x41,0x62,0x6F,0x75,0x74,0\n"
#endif
"_Main_4093:	.byte 0x20,0x20,0x43,0x75,0x72,0x72,0x65,0x6E,0x74,0x20,0x20,0
_Main_8:	.byte 0x4E,0x6F,0x20,0x42,0x72,0x69,0x63,0x6B,0
_Main_9:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x31,0
_Main_10:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x32,0
_Main_11:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x33,0
_Main_12:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x34,0
_Main_13: .ascii \"Save As\"
.byte 0
_Main_14: .ascii \"New\"
.byte 0
_Main_15: .ascii \"Edit Next\"
.byte 0
_Main_4092:	.byte 0x20,0x20,0x20,0x46,0x69,0x6C,0x6C,0x20,0x20,0x20,0
_Main_18:	.byte 0x20,0x20,0x46,0x69,0x6C,0x6C,0x20,0x43,0x75,0x72,0x65,0x6E,0x74,0x20,0x20,0
_Main_end:
");
//======================prefs dialog=======================================
asm("
.data
	.even
Prefs:	.word (Prefs_0-Prefs)
	.word 4
	.byte 120,45
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (Prefs_0-Prefs_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,1,15
	.word (Prefs_1-Prefs_0)
	.word 0
	.word 9
	.byte 8
	.byte 0
| EDIT
	.byte 2,0,1,25
	.word (Prefs_2-Prefs_0)
	.word 10
	.word 9
	.byte 8
	.byte 0

| XFLAGS
	.byte 15,128,0,0
	.word 4
	.word 0
	.word 0
	.word 0
| END
	.byte 0,0

Prefs_0:	.ascii \"Jedit "VERSION_STR" Settings\"
.byte 0
Prefs_1:	.byte 0x4B,0x65,0x79,0x20,0x72,0x65,0x70,0x65,0x61,0x74,0x20,0x64,0x65,0x6C,0x61,0x79,0
Prefs_2:	.byte 0x4B,0x65,0x79,0x20,0x72,0x65,0x70,0x65,0x61,0x74,0x20,0x72,0x61,0x74,0x65,0x20
        	.byte 0x20,0
");
//==============================Number of Levels Dialog===========================
asm("
.data
	.global NewLSet
	.align 2
NewLSet:
	.word (NewLSet_0-NewLSet)
	.word 3
	.byte 120,40
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (NewLSet_0-NewLSet_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,8,17
	.word (NewLSet_1-NewLSet_0)
	.word 0
	.word 9
	.byte 8
	.byte 0

| XFLAGS
	.byte 15,128,0,0
	.word 4
	.word 0
	.word 0
	.word 0
| END
	.byte 0,0

NewLSet_0:	.ascii \"Jedit "VERSION_STR" Level Set\"
.byte 0
NewLSet_1:	.ascii \"Num of levels\"
.byte 0
");
//=============================Name of Next Level Dialog====================================
asm("
.data
	.even
NextLevel:
	.word (NextLevel_0-NextLevel)
	.word 2
	.byte 120,40
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (NextLevel_0-NextLevel_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,8,17
	.word (NextLevel_1-NextLevel_0)
	.word 0
	.word 9
	.byte 8
	.byte 0
"/*"
| XFLAGS
	.byte 15,128,0,0
	.word 0x8000	|suposto enable the use of the varilink to select only could'nt get it to work
	.word 0
	.word 0
	.word 0
| END
	.byte 0,0
"*/"
NextLevel_0:	.ascii \"Jedit "VERSION_STR" Next Level Str\"
.byte 0
NextLevel_1:	.ascii \"Next Level\"
.byte 0
");
#else
asm("|created whith ti flash studio and coppied here
|main menue
.text

	.even
Main:	.word (_Main_0-Main)
	.word 2
	.word 18
	.byte 240,18
	.word 6
	.word 0
	.word 0,0
	.long 0xFFFFFFFF
	.long 0xCFFF0000 + ((_Main_4095 - _Main_0))
	.word (__Main_1 - Main)\n"
#ifndef SMALL
	".long 0xCFFE0000 + ((_Main_4094 - _Main_0))
	.word (__Main_5 - Main)\n"
#endif
	".long 0xCFFD0000 + ((_Main_4093 - _Main_0))
	.word (__Main_8 - Main)
	.long 0xCFFC0000 + ((_Main_4092-_Main_0))
	.word (__Main_14 - Main)
	.long 0x80140000 + ((_Main_18 - _Main_0))
	.long 0xFFFFFFFF
__Main_1:
	.long 0x80010000 + ((_Main_14-_Main_0))
	.long 0x80020000 + ((_Main_1-_Main_0))
	.long 0x80030000 + ((_Main_2-_Main_0))
	.long 0x80040000 + ((_Main_13-_Main_0))
	.long 0x80050000 + ((_Main_15-_Main_0))
	.long 0x80060000 + ((_Main_3-_Main_0))
	.long 0x80070000 + ((_Main_4-_Main_0))
	.long 0xFFFFFFFF\n"
#ifndef SMALL
"__Main_5:
	.long 0x80080000 + ((_Main_5-_Main_0))
	.long 0x80090000 + ((_Main_6-_Main_0))
	.long 0x800A0000 + ((_Main_7-_Main_0))
	.long 0xFFFFFFFF\n"
#endif
"__Main_8:
	.long 0x800B0000 + ((_Main_8-_Main_0))
	.long 0x800C0000 + ((_Main_9-_Main_0))
	.long 0x800D0000 + ((_Main_10-_Main_0))
	.long 0x800E0000 + ((_Main_11-_Main_0))
	.long 0x800F0000 + ((_Main_12-_Main_0))
	.long 0xFFFFFFFF
__Main_14:
	.long 0x80100000 + ((_Main_9-_Main_0))
	.long 0x80110000 + ((_Main_10-_Main_0))
	.long 0x80120000 + ((_Main_11-_Main_0))
	.long 0x80130000 + ((_Main_12-_Main_0))
	.long 0xFFFFFFFF
_Main_0:
_Main_4095:	.byte 0x20,0x46,0x69,0x6C,0x65,0x20,0
_Main_1:	.byte 0x4F,0x70,0x65,0x6E,0
_Main_2:	.byte 0x53,0x61,0x76,0x65,0
_Main_3:	.byte 0x50,0x72,0x65,0x66,0x73,0
_Main_4:	.byte 0x51,0x75,0x69,0x74,0\n"
#ifndef SMALL
"_Main_4094:	.byte 0x20,0x48,0x65,0x6C,0x70,0x20,0
_Main_5:	.byte 0x4B,0x65,0x79,0x73,0
_Main_6:	.byte 0x68,0x65,0x6C,0x70,0
_Main_7:	.byte 0x41,0x62,0x6F,0x75,0x74,0\n"
#endif
"_Main_4093:	.byte 0x43,0x75,0x72,0x72,0x65,0x6E,0x74,0
_Main_8:	.byte 0x4E,0x6F,0x20,0x42,0x72,0x69,0x63,0x6B,0
_Main_9:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x31,0
_Main_10:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x32,0
_Main_11:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x33,0
_Main_12:	.byte 0x42,0x72,0x69,0x63,0x6B,0x20,0x34,0
_Main_13: .ascii \"Save As\"
.byte 0
_Main_14: .ascii \"New\"
.byte 0
_Main_15: .ascii \"Edit Next\"
.byte 0
_Main_4092:	.byte 0x20,0x46,0x69,0x6C,0x6C,0x20,0
_Main_18:	.byte 0x46,0x69,0x6C,0x6C,0x20,0x20,0x43,0x75,0x72,0x65,0x6E,0x74,0
_Main_end:
");
//======================prefs dialog=======================================
asm("
.data
	.even
Prefs:	.word (Prefs_0-Prefs)
	.word 4
	.byte 160,55
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (Prefs_0-Prefs_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,1,15
	.word (Prefs_1-Prefs_0)
	.word 0
	.word 9
	.byte 8
	.byte 0
| EDIT
	.byte 2,0,1,28
	.word (Prefs_2-Prefs_0)
	.word 10
	.word 9
	.byte 8
	.byte 0

| END
	.byte 0,0

Prefs_0:	.ascii \"Jedit "VERSION_STR" Settings\"
.byte 0
Prefs_1:	.byte 0x4B,0x65,0x79,0x20,0x72,0x65,0x70,0x65,0x61,0x74,0x20,0x64,0x65,0x6C,0x61,0x79,0
Prefs_2:	.byte 0x4B,0x65,0x79,0x20,0x72,0x65,0x70,0x65,0x61,0x74,0x20,0x72,0x61,0x74,0x65,0x20,0
");
//==============================Number of Levels Dialog===========================
asm("
.data
	.global NewLSet
	.align 2
NewLSet:
	.word (NewLSet_0-NewLSet)
	.word 3
	.byte 160,45
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (NewLSet_0-NewLSet_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,8,17
	.word (NewLSet_1-NewLSet_0)
	.word 0
	.word 9
	.byte 8
	.byte 0

| END
	.byte 0,0

NewLSet_0:	.ascii \"Jedit "VERSION_STR" Level Set\"
.byte 0
NewLSet_1:	.ascii \"Num of levels\"
.byte 0
");
//=============================Name of Next Level Dialog====================================
asm("
.data
	.even
NextLevel:
	.word (NextLevel_0-NextLevel)
	.word 2
	.byte 160,45
	.long NoCallBack
| HEADER
	.byte 8,128,0,0
	.word (NextLevel_0-NextLevel_0)
	.byte 1,4
	.byte 0,0,0,0
| EDIT
	.byte 2,0,8,17
	.word (NextLevel_1-NextLevel_0)
	.word 0
	.word 9
	.byte 8
	.byte 0
"/*"
| XFLAGS
	.byte 15,128,0,0
	.word 0x8000	|suposto enable the use of the varilink to select only could'nt get it to work
	.word 0
	.word 0
	.word 0
| END
	.byte 0,0
"*/"
NextLevel_0:	.ascii \"Jedit "VERSION_STR" Next Level Str\"
.byte 0
NextLevel_1:	.ascii \"Next Level\"
.byte 0
");
#endif
