// C Source File
// Created 2/26/2004; 6:16:07 PM

#include "defs.h"
#include "extgraph.h"


	void show_scores(void);
	short loadLevel(LEVEL *dest,HSYM src);
	void loadScores(HIGH_SCORES *dest);
	HSym loadLset(LEVEL *dest,HSYM src);
	short loadLsetNext(LEVEL *dest,HSYM *lset);
	void drawStat(GAME *stats);
	void endGame(GAME *vars)__attribute__((noreturn));
	void handleTeacherKey(LEVEL *saveLevel,GAME *saveStats)__attribute__((noreturn));
	short loadFromTeacherKey(LEVEL *saveLevel,GAME *saveStats);
	void leadOut(const char* msg)__attribute__((noreturn));

INT_HANDLER save_int_1;

__attribute__((noreturn)) void _main(void)
{
	#ifdef USE_VTI
	long t;
	#endif
	LEVEL curL;
	unsigned short i;
	randomize();
	char buff[18];
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 15);
	save_int_1 = GetIntVec (AUTO_INT_1);
	static const ESQ tags[3]={OTH_TAG,OTH_TAG,0};
	static const char *(lev[2])={"flvl","lset"};
	#ifndef SMALL
		static const char*(sct[1])={"HSC"};
	#endif
	GAME vars;
	int b=0,j,k,rnd,r=0,key;
	unsigned short teach;
	HSym l;
	void *fptr;
	if(!(teach=loadFromTeacherKey(&curL,&vars))){
			memcpy(&vars,&(GAME){77,55,0,1,X_START,Y_START,0,3,0,0,0,0,0,0,-1,0,0,"","","",HS_NULL,SHOTS,0,0,{}},sizeof(GAME));
			memcpy(&curL,&(LEVEL){1,{ {0,0,0,4,4,4,0,0,0,0},//column 0
																{0,0,0,4,1,4,0,0,0,0},//column 1
																{0,0,0,4,1,4,0,0,0,0},//column 2
																{0,0,0,4,4,4,0,0,0,3},//column 3
																{0,0,0,4,4,4,0,0,0,3},//column 4
																{0,0,0,4,4,4,0,0,0,3},//column 5
																{0,0,0,4,1,4,0,0,0,0},//column 6
																{0,0,0,4,1,4,0,0,0,0},//column 7
																{0,0,0,4,4,4,0,0,0,0}//column 8
																},""},sizeof(LEVEL));
			show_scores();
			do
			{
				#ifdef USE_TI89
					#if defined(USE_TI92PLUS) || defined(USE_V200)
						if(!CALCULATOR)
					#endif
							memset(LCD_MEM+30*95,0,30*5);
				#endif
			  key = MenuPopup (&Mmenu, CENTER, CENTER, 0);
			  if(key == 0)leadOut("Jpong "VERTION_STR" By Jesse Frey");
				#ifndef SMALL
				  if(key==8)
				  {
				  	l=VarOpen(tags+1,sct);
				  	if(l.folder!=0 && l.offset!=0)
				  	{
				  		HSYMtoName (l,buff);
				  		if(SymMove(SYMSTR ("pscores"),SYMSTR(buff)))
				  		{
				  			show_scores();
				  		}
				  		else
				  			DlgMessage ("ERROR", "score rename did not work",BT_OK,BT_NONE);
				  	}
				  }
				  if(key == 7)
				  {
				  	clrscr();
				  	FontSetSys(F_8x10);
				  	memset(LCD_MEM+10*30,0xFF,30);
				  	memset(LCD_MEM+PSEUDO_CONST_SCREEN(19*30,21*30),0xFF,30);
				  	DrawStr(PSEUDO_CONST_SCREEN(35,65),0,"JPONG  KEYS",A_NORMAL);
						FontSetSys(PSEUDO_CONST_SCREEN(F_4x6,F_6x8));
						DrawStr(PSEUDO_CONST_SCREEN(58,71),PSEUDO_CONST_SCREEN(13,12),"By Jesse Frey",A_NORMAL);
						for(j=0;j<9;j++){
							DrawStr(10,PSEUDO_CONST_SCREEN(23,25)+j*PSEUDO_CONST_SCREEN(8,11),KEY(keys89[j][0],keys92plus[j][0],keys92plus[j][0]),A_NORMAL);
							DrawStr(PSEUDO_CONST_SCREEN(50,60),PSEUDO_CONST_SCREEN(23,25)+j*PSEUDO_CONST_SCREEN(8,11),KEY(keys89[j][1],keys92plus[j][1],keys92plus[j][1]),A_NORMAL);
						}
						if(KEY_ESC==ngetchx())leadOut("Jpong "VERTION_STR" By Jesse Frey");
				  }

					  if(key==6)
					  {
					  	if(DlgMessage ("WARNING ABOUT TO DELETE SCORES", "are you sure?",BT_YES,BT_NO)==KEY_ENTER)
					  	{
						  	SymDel(SYMSTR ("pscores"));
								show_scores();
					  	}

					  }
			  #endif
			  if(key == 5)
			  {
					show_scores();
					ngetchx();
			  }
			  #ifndef SMALL
					if(key == 3)
					{
						clrscr();
						FontSetSys(PSEUDO_CONST_SCREEN(F_4x6,F_6x8));
						#if (defined(USE_TI92PLUS) || defined(USE_V200)) && defined(USE_TI89)
							if(!CALCULATOR){
						#endif
						#ifdef USE_TI89
							puts("To use the level stored internaley choose Int\n"
							"Level. To use a level created whith jediedit\n"
							"choose Ext Level.\n\n"
							"     Gameplay is pritty self explanatory press\n"
							"2nd to start and use the up, down, right and\n"
							"left arrows to move the pattle to deflect the\n"
							"ball so it hits the bricks. once all destructable\n"
							"bricks are clear you win the level.\n\n"
							"     Scoring, pritty simple each time you hit a\n"
							"brick you get ten points, if you have no\n"
							"powerups. every time you get a powerup you\n"
							"also get 10 points. once you finish the game\n"
							"you get 15 points for every life you have.");
						#endif
						#if (defined(USE_TI92PLUS) || defined(USE_V200)) && defined(USE_TI89)
							}else
						#endif
						#if defined(USE_TI92PLUS) || defined(USE_V200)
						{
							puts("To use the level stored internaley\n"
							"choose Int Level.To use a level created\n"
							"whith jediedit choose Ext Level.\n"
							" Gameplay is pritty self explanatory\n"
							"press 2nd to start and use the arrows\n"
							"to move the pattle to deflect the ball\n"
							"so it hits the bricks. once all bricks\n"
							"are clear you win the level.\n"
							" Scoring, pritty simple each time you\n"
							"hit a brick you get ten points, if you\n"
							"have no powerups. every time you get a\n"
							"powerup you also get 10 points. once\n"
							"you finish the game you get 15 points\n"
							"for every life you have.");
						}
						#endif
						memset(LCD_MEM+PSEUDO_CONST_SCREEN(92*30,116*30),0xFF,30);
						DrawStr(PSEUDO_CONST_SCREEN(25,35),PSEUDO_CONST_SCREEN(94,118),EXTGRAPH_VERSION_PWDSTR,A_NORMAL);
						if(KEY_ESC==ngetchx())leadOut("Jpong "VERTION_STR" By Jesse Frey");
						#if defined(USE_TI92PLUS) || defined(USE_V200)
							#ifdef USE_TI89
								if(CALCULATOR)
							#endif
									memset(LCD_MEM+30*116,0,30*6);
						#endif
					}
					if(key == 4)
					{
						clrscr();
						FontSetSys(PSEUDO_CONST_SCREEN(F_4x6,F_6x8));
						for(j=0;j<7;j++){
							Sprite8_OR_R(4,4+PSEUDO_CONST_SCREEN(11,13)*j,8,pwu[j], LCD_MEM);
							DrawStr(16,5+j*PSEUDO_CONST_SCREEN(11,13),pwrUp[j],A_NORMAL);
						}
						DrawStr(16,PSEUDO_CONST_SCREEN(84,97),"* Display icon in stat line",A_NORMAL);
						if(KEY_ESC==ngetchx())leadOut("Jpong "VERTION_STR" By Jesse Frey");
					}
				#endif
			}while(key!=2 && key!=1);
			FontSetSys(F_6x8);
			switch(key)
			{
				case 2:
				l=VarOpen(tags,lev);
				if(l.folder)
				{
					HSYMtoName(l,buff);
					fptr=strchr(buff,'\\');
					*(char*)fptr=0;
				 	strcpy(vars.level,fptr+1);
					strcpy(vars.folder,buff);
					strcpy(vars.scl,vars.level);
					if(VarOptList[0]==1){
						if(loadLevel(&curL,l)){
							vars.lset=HS_NULL;
							break;
						}
					}else{
						if((vars.lset=loadLset(&curL,l)).folder){
							curL.nlevel[0]=0;
							break;
						}
					}
				}
			 	default:
				 	curL.ll=1;
				 	strcpy(vars.level,"built in");
				 	strcpy(vars.scl,"built in");
			 }
		}

	SetIntVec (AUTO_INT_1,DUMMY_HANDLER);
	for(;;)//main loop
	{
		clrscr();
		if(!teach){
			vars.lvls++;
			if(vars.pwrup!=-1)
				Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
			vars.pwrup=-1;//reset power ups
			vars.psc=0;//reset speed
			vars.shoot=0;//reset shooters
			//clear the shot array
			for(i=0;i<SHOTS;i++)
			{
				Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
				vars.shots[i].state=0;
			}
			vars.lft=SHOTS;//kill all remaining bullets
			vars.ts=0;//make the ball bounce off the bricks
			vars.ebs=0;//reset speed power up
			vars.xp=77;//reset ball position
			vars.yp=55;//reset ball position
			vars.ya=1;//reset ball acceleration
			vars.xa=0;//reset ball acceleration
			vars.x=X_START;//reset pattle position
			vars.y=Y_START;//reset pattle positnon
			if(vars.pwrup!=-1)
				Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
			vars.pwrup=-1;
			vars.ebs=0;
			vars.remain=0;
			key=1;
		}
		//draw pattle
		Sprite16_RPLC_R(vars.x,vars.y,4,brick[4], LCD_MEM);
		//draw ball
		Sprite8_OR_R(vars.xp,vars.yp+1,4,ball, LCD_MEM);
		//draw bricks
		for(j=0;j<10;j++)
		{
			for(k=0;k<9;k++)
			{
				Sprite16_RPLC_R(BRICK_X,BRICK_Y,4,brick[curL.bricks[k][j]], LCD_MEM);
				if(!teach){
					if(curL.bricks[k][j]==1 || curL.bricks[k][j]==3)vars.remain++;
					if(curL.bricks[k][j]==4)vars.remain+=2;
				}
			}
		}
		teach=FALSE;
		FontSetSys (F_6x8);
		while(_rowread(0))delay();
		sprintf(buff,"%s Level",vars.level);
		DrawStr(50,60,buff,A_REPLACE);
		DrawStr(60,70,KEY("Press 2ND","Press HAND","Press HAND"),A_NORMAL);
		redrawStat(&vars);
		#if defined(USE_TI92PLUS) || defined(USE_V200)
			#ifdef USE_TI89
				if(CALCULATOR)
			#endif
				FastLine_Draw_R(LCD_MEM,160,0,160,128);
		#endif
		OSTimerRestart(APD_TIMER);
		while(!_keytest(SHOOT))
		{
			if (OSTimerExpired(APD_TIMER) || (~(*(volatile unsigned char*)0x60001a)&0x2)) {
      off();
      OSTimerRestart(APD_TIMER);
      }
      if(_keytest(TEACH))handleTeacherKey(&curL,&vars);
      if(_keytest(QUIT))endGame(&vars);
      if(_keytest(RR_PLUS)){
				OSContrastUp();
				while(_keytest(RR_PLUS))delay();
      }
      if(_keytest(RR_MINUS)){
				OSContrastDn();
				while(_keytest(RR_MINUS))delay();
      }
      delay();
		}
		memset(LCD_MEM+30*60,0,30*20);
		#if defined(USE_TI92PLUS) || defined(USE_V200)
			#ifdef USE_TI89
				if(CALCULATOR)
			#endif
				FastLine_Draw_R(LCD_MEM,160,0,160,128);
		#endif
		while(vars.remain>0 )
		{
			if(r>B_SPEED+vars.ebs)
			{
				Sprite8_AND_R(vars.xp,vars.yp,4,msk, LCD_MEM);

				if(vars.yp<=MIN_YP){
					vars.ya=abs(vars.ya);
				}

				if(vars.xp<MIN_XP ){
					vars.xa=abs(vars.xa);
				}

				if(vars.xp>=MAX_XP){
					vars.xa=-1*abs(vars.xa);
				}

				if(vars.yp>=MAX_YP)//if it went off the bottom
				{
					if(vars.lvs==0)endGame(&vars);//if you have no lives end the game
					Sprite16_RPLC_R(vars.x,vars.y,4,brick[0], LCD_MEM);//remove old pattle
					vars.lvs--;//loos a life
					if(vars.pwrup!=-1)
						Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
					vars.pwrup=-1;//reset power ups
					vars.psc=0;

					//clear the shot array
					for(i=0;i<SHOTS && vars.shoot!=0;i++)
					{
						if(vars.shots[i].state!=0)
						{
							Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
							vars.shots[i].state=0;
						}
					}
					vars.shoot=0;//reset shooters
					vars.lft=SHOTS;//kill all remaining bullets
					vars.ts=0;//make the ball bounce off the curL.bricks
					vars.ebs=0;//reset speed power up
					vars.xp=77;//reset ball position
					vars.yp=55;//reset ball position
					vars.ya=1;//reset ball acceleration
					vars.xa=0;//reset ball acceleration
					vars.x=X_START;//reset pattle position
					vars.y=Y_START;//reset pattle positnon
					Sprite16_RPLC_R(vars.x,vars.y,4,brick[4], LCD_MEM);//draw new pattle
					FontSetSys (F_6x8);
					DrawStr(60,60,KEY("Press 2ND","Press HAND","Press HAND"),A_NORMAL);
					Sprite8_OR_R(vars.xp,vars.yp+1,4,ball, LCD_MEM);//draw ball
					redrawStat(&vars);
					#if defined(USE_TI92PLUS) || defined(USE_V200)
						#ifdef USE_TI89
							if(CALCULATOR)
						#endif
							FastLine_Draw_R(LCD_MEM,160,0,160,128);
					#endif
					while(_rowread(0))delay();
					OSTimerRestart(APD_TIMER);
					while(!_keytest(SHOOT))//waight for 2nd
					{
						if (OSTimerExpired(APD_TIMER) || (~(*(volatile unsigned char*)0x60001a)&0x2)) {
            off();
            OSTimerRestart(APD_TIMER);
            }
            if(_keytest(QUIT))endGame(&vars);
            if(_keytest(TEACH))handleTeacherKey(&curL,&vars);
			      if(_keytest(RR_PLUS)){
							OSContrastUp();
							while(_keytest(RR_PLUS))delay();
			      }
			      if(_keytest(RR_MINUS)){
							OSContrastDn();
							while(_keytest(RR_MINUS))delay();
			      }
            delay();
					}
					FontSetSys (F_6x8);
					memset(LCD_MEM+30*60,0,30*20);
					#if defined(USE_TI92PLUS) || defined(USE_V200)
						#ifdef USE_TI89
							if(CALCULATOR)
						#endif
							FastLine_Draw_R(LCD_MEM,160,0,160,128);
					#endif
					while(!_rowread(0))delay();
				}

				vars.xp+=vars.xa;
				vars.yp+=vars.ya;
				//check to see if it hit the bricks
				for(j=0;j<10;j++)
				{
					for(k=0;k<9;k++)
					{
						if(curL.bricks[k][j]!=0){
							Sprite16_RPLC_R(BRICK_X,BRICK_Y,4, brick[curL.bricks[k][j]], LCD_MEM);
						}
						if((( vars.xp+2>=BRICK_X && vars.xp+2<=BRICK_X+16 && vars.yp>=BRICK_Y && vars.yp<=BRICK_Y+4) || (vars.xp+6>=BRICK_X && vars.xp+6<=BRICK_X+16 && vars.yp+4>=BRICK_Y && vars.yp+4<=BRICK_Y+4)) && curL.bricks[k][j]!=0){
							if( (rnd=random(35))<7 && vars.pwrup==-1 && curL.bricks[k][j]!=0 && curL.bricks[k][j]!=2){
									vars.px=vars.xp;
									vars.py=vars.yp;
									vars.pwrup=rnd;
							}
							if(vars.ts==0 && (vars.yp<=BRICK_Y-1 || vars.yp>=BRICK_Y+3))vars.ya*=-1;
							if(vars.ts==0 && (vars.xp+2<=BRICK_X || vars.xp+6>=BRICK_X+16))vars.xa*=-1;
							if(curL.bricks[k][j]==1)
							{

								curL.bricks[k][j]=0;
								Sprite16_RPLC_R(BRICK_X,BRICK_Y,4,brick[0], LCD_MEM);
								vars.remain--;
								vars.score+=SC_ADD;
							}
							else
							{
									if(curL.bricks[k][j]==3)
									{
										vars.remain--;
										vars.score+=SC_ADD;
										curL.bricks[k][j]=2;
									}
									else
									{
										if(curL.bricks[k][j]==4)
										{
											vars.remain--;
											vars.score+=SC_ADD;
											curL.bricks[k][j]=1;
										}
									}
							}
						}

					}
				}
				//check for contact whith pattle
				if(vars.x<=vars.xp+4 && (vars.x+16)>=vars.xp && (vars.yp+4>=vars.y && vars.yp<=vars.y))
				{
					vars.ya=-1;
					if(vars.xp+2>=vars.x+10 && vars.xa==0)vars.xa=1;
					if(vars.xp+2<=vars.x+6 && vars.xa==0)vars.xa=-1;
					if(vars.xp+2>vars.x+7 && vars.xp+2<vars.x+9)vars.xa=0;
					if(vars.xp+2>vars.x+12)vars.xa=1;
					if(vars.xp+2<vars.x+4)vars.xa=-1;
					if(vars.xp+2<vars.x+2)vars.xa=-2;
					if(vars.xp+2>vars.x+14)vars.xa=2;
				}
				r=0;
				Sprite8_OR_R(vars.xp,vars.yp,4,ball, LCD_MEM);
			}
			else
			{
				delay();
			}
			r++;
			if(OSTimerExpired (USER_TIMER))
			{
				drawStat(&vars);
			}
			//move power up
			if(vars.pwrup!=-1 && b>P_SPEED)
			{
				b=0;
				Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
				vars.py++;
				Sprite8_OR_R(vars.px,vars.py,8,pwu[vars.pwrup], LCD_MEM);
				if(vars.py>MAX_Y-5)
				{
					vars.pwrup=-1;
					Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
				}
				if((vars.px<vars.x+16 && vars.px+8>vars.x) && (vars.py+8>vars.y && vars.py<vars.y+4))
				{
					vars.score+=10;
					switch(vars.pwrup)
					{
						case 0:
							Sprite8_RPLC_R(3,PSEUDO_CONST_SCREEN(94,121),6,pwu[0],LCD_MEM);
							vars.ebs=-2;
							vars.psc=3;
						break;
						case 1:
							Sprite8_RPLC_R(3,PSEUDO_CONST_SCREEN(94,121),6,&pwu[1][2],LCD_MEM);
							vars.ebs=2;
							vars.psc=-2;
						break;
						case 2:
							Sprite8_RPLC_R(28,PSEUDO_CONST_SCREEN(95,122),6,&pwu[2][1], LCD_MEM);
							vars.ts=-3;
						break;
						case 3:
							vars.score+=40;
							sprintf(buff,"score %i",vars.score);
							DrawStr(116,PSEUDO_CONST_SCREEN(94,121),buff,A_REPLACE);
						break;
						case 4:
							Sprite8_RPLC_R(16,PSEUDO_CONST_SCREEN(95,122),4,pwu[4], LCD_MEM);
							if(vars.shoot==0)
							{
								vars.sd=0;
								vars.ct=1;
							}
							vars.shoot=1;
						break;/*
						case 5:
							Sprite8_OR_R(40,PSEUDO_CONST_SCREEN(95,122),4,&pwu[5][4], LCD_MEM);

						break;*/
						case 6:
							vars.lvs++;
							sprintf(buff,"lvs %i",vars.lvs);
							DrawStr(90,PSEUDO_CONST_SCREEN(94,121),buff,A_REPLACE);
						break;
					}
					Sprite8_AND_R(vars.px,vars.py,8,(char*)brick, LCD_MEM);
					vars.pwrup=-1;
				}

			}
			b++;
			//shooter code
			if(vars.shoot==1){
					vars.ct++;
					if(vars.ct>20)vars.ct=0;
					if(_keytest (SHOOT))
						vars.sd=1;
					if( vars.sd==1  && vars.ct==0 && vars.lft>1)
					{
						vars.sd=0;
						for(i=0;i<SHOTS;i++)
						{
							if(vars.shots[i].state==0)break;
						}
						vars.lft--;
						vars.shots[i].x=vars.x;
						vars.shots[i].state=1;
						vars.shots[i].y=vars.y;
						Sprite8_OR_R(vars.shots[i].x,vars.shots[i].y,5,st[1], LCD_MEM);
						for(i=0;i<SHOTS;i++)
						{
							if(vars.shots[i].state==0)break;
						}
						vars.lft--;
						vars.shots[i].x=vars.x+13;
						vars.shots[i].state=1;
						vars.shots[i].y=vars.y;
						Sprite8_OR_R(vars.shots[i].x,vars.shots[i].y,5,st[1], LCD_MEM);
					}
					for(i=0;i<SHOTS;i++)
					{
						if(vars.shots[i].state==1)
						{
							k=(vars.shots[i].x-2)/17;
							j=vars.shots[i].y/5;
							if(j>=0 && j<10 && k>=0 && k<9)
							{
								if( (rnd=random(55))<7 && vars.pwrup==-1 && curL.bricks[k][j]!=0 && curL.bricks[k][j]!=2){
									vars.px=vars.shots[i].x;
									vars.py=vars.shots[i].y;
									vars.pwrup=rnd;
								}
								switch (curL.bricks[k][j])
								{
									case 0:
									break;
									case 1:
										Sprite16_RPLC_R(BRICK_X,BRICK_Y,4,brick[0], LCD_MEM);
										curL.bricks[k][j]=0;
										vars.remain--;
										vars.score++;
										vars.shots[i].state=0;
										Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
										vars.lft++;
									break;
									case 2:
										if(vars.ts==-3)break;
									 vars.shots[i].state=0;
									 Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
									 vars.lft++;
									break;
									case 3:
										Sprite16_RPLC_R(BRICK_X,BRICK_Y,4,brick[2],LCD_MEM);
										vars.remain--;
										vars.score++;
										curL.bricks[k][j]=2;
										vars.shots[i].state=0;
										Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
										vars.lft++;
									break;
									case 4:
											Sprite16_RPLC_R(BRICK_X,BRICK_Y,4,brick[1], LCD_MEM);
											vars.remain--;
											vars.score++;
											curL.bricks[k][j]=1;
											vars.shots[i].state=0;
											Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
											vars.lft++;
									break;
								}
							}
							if(vars.shots[i].y<0 && vars.shots[i].state==1)
							{
								vars.shots[i].state=0;
								vars.lft++;
								Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
							}
							else
							{
								if(vars.shots[i].state==1)
								{
									Sprite8_AND_R(vars.shots[i].x,vars.shots[i].y,5,st[0], LCD_MEM);
									vars.shots[i].y--;
									Sprite8_OR_R(vars.shots[i].x,vars.shots[i].y,5,st[1], LCD_MEM);
								}

							}

						}
					}
			}
			//pattle code

			Sprite16_RPLC_R(vars.x,vars.y,4,brick[0], LCD_MEM);//remove pattle

			//check arrows
			if(_keytest(P_LEFT))vars.x--;
			if(_keytest(P_RIGHT))vars.x++;
			if(_keytest(P_DOWN))vars.y++;
			if(_keytest(P_UP))vars.y--;

			if(_keytest(QUIT))endGame(&vars);

			if(_keytest(TEACH))handleTeacherKey(&curL,&vars);


			//check shift and pause if nessisary
			if(_keytest(PAUSE) ||  (~(*(volatile unsigned char*)0x60001a)&0x2))
			{
					if(~(*(volatile unsigned char*)0x60001a)&0x2)off();//turn off if apps pressed
					FontSetSys (F_6x8);
					DrawStr(40,60,"Paused Press 2nd",A_NORMAL);
					Sprite16_RPLC_R(vars.x,vars.y,4,brick[4],LCD_MEM);
					while(_keytest(PAUSE))delay();
					OSTimerRestart(APD_TIMER);
					while(!(_keytest(PAUSE) || _keytest(SHOOT)))//waight for 2nd or shift
					{
						if (OSTimerExpired(APD_TIMER) ||(~(*(volatile unsigned char*)0x60001a)&0x2)) {
			      off();
			      OSTimerRestart(APD_TIMER);
			      }
			      if(_keytest(QUIT))endGame(&vars);
			      if(_keytest(TEACH))handleTeacherKey(&curL,&vars);
			      if(_keytest(RR_PLUS)){
							OSContrastUp();
							while(_keytest(RR_PLUS))delay();
			      }
			      if(_keytest(RR_MINUS)){
							OSContrastDn();
							while(_keytest(RR_MINUS))delay();
			      }
			      delay();
					}
					while(_rowread(0))delay();
					memset(LCD_MEM+30*60,0,30*20);
			}
			//check to see if pattle has gon too far
			if(vars.x<MIN_X){
				vars.x=MIN_X;
			}

			if(vars.x>MAX_X){
				vars.x=MAX_X;
			}

			if(vars.y<MIN_Y){
				vars.y=MIN_Y;
			}

			if(vars.y>MAX_Y){
				vars.y=MAX_Y;
			}

			//draw pattle and ball
			Sprite16_RPLC_R(vars.x,vars.y,4,brick[4], LCD_MEM);
			Sprite8_OR_R(vars.xp,vars.yp,4,ball, LCD_MEM);
		}//end game loop
		if(curL.ll==1)
			break;
		if(!(vars.lset).folder){
			strcpy(vars.level,curL.nlevel);
			if(!loadLevel(&curL,FindSymInFolder(SYMSTR(curL.nlevel),SYMSTR(vars.folder))))
			{
				SetIntVec (AUTO_INT_1, save_int_1);	//restor auto int 1
				DlgMessage ("ERROR", "The next level does not exist or is not a valid level", BT_OK, BT_NONE);
				break;
			}
		}else{
			if(!loadLsetNext(&curL,&(vars.lset)))break;
		}
	}//game loop
	endGame(&vars);
}//============================================end Main=======================================================

void show_scores()
{
			HIGH_SCORES scores={{1200,1001,640,500,420,362,342,286,210,159},
			{"default","default","default","default","default","default","default","default","default","default"},
			{"none","none","none","none","none","none","none","none","none","none"},{0,0,0,0,0,0,0,0,0,0}};
			char buff[6];
			loadScores(&scores);
  		clrscr();
			FontSetSys(F_8x10);
			DrawStr(PSEUDO_CONST_SCREEN(30,70),0,"HIGH SCORES",A_NORMAL);//title
			FontSetSys(PSEUDO_CONST_SCREEN(F_4x6,F_6x8));
			//draw names
			DrawStr(0,10,PSEUDO_CONST_SCREEN("Name        level #       Level                 Score",
			"Name      level #     Level       Score"),A_NORMAL);
			memset(LCD_MEM+PSEUDO_CONST_SCREEN(16*30,18*30),0xFF,60);
			unsigned short j;
			for (j=0; j<10; j++) {
				//draw player names
				DrawStr(0,PSEUDO_CONST_SCREEN(19+8*j,21+10*j),scores.names[j],A_NORMAL);
				//draw level#
				sprintf(buff,"%u",scores.lnum[j]);
				DrawStr(PSEUDO_CONST_SCREEN(45,70),PSEUDO_CONST_SCREEN(19+8*j,21+10*j),buff,A_NORMAL);
				//draw level names
				DrawStr(PSEUDO_CONST_SCREEN(66,132),PSEUDO_CONST_SCREEN(19+8*j,21+10*j),scores.levels[j],A_NORMAL);
				//draw scores
				sprintf(buff,"%u",scores.scores[j]);
				DrawStr(PSEUDO_CONST_SCREEN(130,205),PSEUDO_CONST_SCREEN(19+8*j,21+10*j),buff,A_NORMAL);
			}
}

void loadScores(HIGH_SCORES *dest){
	SYM_ENTRY *symPtr;
	void *fptr;
	if ((symPtr=SymFindPtr (SYMSTR("pscores"),0))) {
		fptr=HeapDeref(symPtr->handle);
		memcpy(dest,fptr+2,sizeof(HIGH_SCORES));
	}
}

HSym loadLset(LEVEL *dest,HSYM src){
	void *fptr;
	SYM_ENTRY *symPtr;
	if((symPtr=DerefSym(src)))
	{
		fptr=HeapDeref(symPtr->handle);
		memcpy(dest,fptr+2,(sizeof(unsigned char)*90+2));
		if(*(unsigned short*)fptr!=2+90*dest->ll+7)return HS_NULL;
		return (HSym){symPtr->handle,(sizeof(unsigned char)*90+4)};
	}
	return HS_NULL;
}

short loadLsetNext(LEVEL *dest,HSYM *lset){
	if(dest->ll<=0)return FALSE;
	dest->ll--;
	memcpy(dest->bricks,DerefSym(*lset),sizeof(unsigned char)*90);
	lset->offset+=90;
	return TRUE;
}

short loadLevel(LEVEL *dest,HSYM src){
	void *fptr;
	SYM_ENTRY *symPtr;
	if((symPtr=DerefSym(src)))
	{
		fptr=HeapDeref(symPtr->handle);
		if(*(short*)fptr<97)return FALSE;
		memcpy(dest,fptr+2,(*(unsigned short*)(fptr+2))?(sizeof(unsigned char)*90+2):sizeof(LEVEL));
		return TRUE;
	}
	return FALSE;
}

void endGame(GAME *vars){
	#ifdef USE_VTI
	long t;
	#endif
	#define tl (tn+10)
	int z,ts;
	HANDLE fileh;
	SYM_ENTRY *symPtr;
	void *fptr;
	HIGH_SCORES scores={{1200,1001,640,500,420,362,342,286,210,159},
	{"default","default","default","default","default","default","default","default","default","default"},
	{"none","none","none","none","none","none","none","none","none","none"},{}};
	char name[10]="name?",tn[20];
	EM_moveSymFromExtMem (SYMSTR("psave"),HS_NULL);
	SymDel(SYMSTR("psave"));
	while(_rowread(0))delay();// waight for the user to release all keys
	if(vars->remain==0){
		clrscr();
		FontSetSys (F_6x8);
		DrawStr(15,50,"Congrats You won!!!!!!!!!",A_NORMAL);
		while(!_rowread(0))delay();
		while(_rowread(0))delay();
	}
	while(_rowread(0))delay();
	SetIntVec (AUTO_INT_1, save_int_1);	//restor auto int 1
	vars->score+=vars->lvs*15;
	clrscr();
	FontSetSys (F_8x10);
	DrawStr(40,25,"GAME OVER",A_NORMAL);
	sprintf(tn,"your score is %i",vars->score);
	DrawStr(10,40,tn,A_REPLACE);
	while(!_rowread(0))delay();
	while(_rowread(0))delay();// waight for the user to release all keys
	loadScores(&scores);
	if(vars->score>scores.scores[9]){
			GKeyFlush();
			HANDLE handle = DialogNewSimple(PSEUDO_CONST_SCREEN(140,160),60);
			DialogAddTitle(handle,"CONGRADULATONS!!!!!!",BT_OK,BT_NONE);
			DialogAddText(handle,3,20,"you got a high score");
			DialogAddRequest (handle,3,30, "enter your name",0,9,9);
			DialogDo(handle, CENTER, CENTER, name, NULL);
		  HeapFree (handle);
			scores.scores[9]=vars->score;
			strcpy(scores.names[9],name);
			strcpy(scores.levels[9],vars->scl);
			scores.lnum[9]=vars->lvls;

			for(z=8;z>=0;z--)
			{
				if(scores.scores[z+1]>scores.scores[z]){//if the score at z is greater than the one above it then swap
					//swap the scores
					ts=scores.scores[z];
					scores.scores[z]=scores.scores[z+1];
					scores.scores[z+1]=ts;
					strcpy(tn,scores.names[z]);
					strcpy(scores.names[z],scores.names[z+1]);
					strcpy(scores.names[z+1],tn);
					strcpy(tl,scores.levels[z]);
					strcpy(scores.levels[z],scores.levels[z+1]);
					strcpy(scores.levels[z+1],tl);
					ts=scores.lnum[z];
					scores.lnum[z]=scores.lnum[z+1];
					scores.lnum[z+1]=ts;
				}
			}

			EM_moveSymFromExtMem (SYMSTR("pscores"),HS_NULL);//unarchive the highscore varable
			if((fileh=HeapAlloc(238))){
				if ((symPtr=DerefSym(SymAdd(SYMSTR("pscores"))))){
					fptr=HeapDeref(symPtr->handle=fileh);
					*(short*)fptr=236;
					memcpy(fptr+2,&scores,sizeof(HIGH_SCORES));
					memcpy(fptr+2+sizeof(HIGH_SCORES),(char[6]){0,'H','S','C',0,0xF8},6);
				}else{
					HeapFree(fileh);
				}
			}
	}
	EM_moveSymToExtMem (SYMSTR("pscores"),HS_NULL);//archive the highscore varable
	OSFreeTimer (USER_TIMER);
	show_scores();
	ngetchx();
	leadOut("Jpong "VERTION_STR" By Jesse Frey");
	#undef tl
}
void leadOut(const char* msg){
  WINDOW *window=FirstWindow;
  do{
  	//set the Dirty flag in all windows
		window->Flags|=WF_DIRTY;
		window=window->Next;
  }while(window!=NULL);
  #ifdef USE_TI89
  	memset(LCD_MEM+93*30,0xFF,20);
  #endif
  #if defined(USE_TI92PLUS) || defined(USE_V200)
  	memset(LCD_MEM+121*30,0xFF,30);
  #endif
  //redraw Home Screen Menu
  MenuUpdate();
  ST_helpMsg(msg);
  exit(0);
 }

void handleTeacherKey(LEVEL *saveLevel,GAME *saveStats){
	#ifdef USE_VTI
	long t;
	#endif
	HANDLE fileh=HeapAlloc(sizeof(GAME)+sizeof(LEVEL)+8);
	void *fptr;
	EM_moveSymFromExtMem (SYMSTR("psave"),HS_NULL);
	SYM_ENTRY *symptr=DerefSym(SymAdd(SYMSTR("psave")));
	while(_rowread(0))delay();// waight for the user to release all keys
	SetIntVec (AUTO_INT_1, save_int_1);	//restor auto int 1
	if(!symptr){
		HeapFree(fileh);
		leadOut("Error Game not saved!");
	}
	symptr->handle=fileh;
	fptr=HeapDeref(fileh);
	*(short*)fptr=sizeof(GAME)+sizeof(LEVEL)+6;
	memcpy(fptr+2,saveStats,sizeof(GAME));
	memcpy(fptr+2+sizeof(GAME),saveLevel,sizeof(LEVEL));
	memcpy(fptr+2+sizeof(GAME)+sizeof(LEVEL),(char[6]){0,'S','A','V',0,0xF8},6);
	EM_moveSymToExtMem (SYMSTR("psave"),HS_NULL);
	leadOut("Game saved!");
}

short loadFromTeacherKey(LEVEL *saveLevel,GAME *saveStats){
	void *fptr;
	SYM_ENTRY *symptr=DerefSym(SymFind(SYMSTR("psave")));
	if(!symptr){
		return FALSE;
	}
	fptr=HeapDeref(symptr->handle);
	if(!(*(short*)fptr==sizeof(GAME)+sizeof(LEVEL)+6))return FALSE;
	memcpy(saveStats,fptr+2,sizeof(GAME));
	memcpy(saveLevel,fptr+2+sizeof(GAME),sizeof(LEVEL));
	//if we are playing a level set reaload it
	if((saveStats->lset).folder){
		symptr=DerefSym(FindSymInFolder(SYMSTR(saveStats->level),SYMSTR(saveStats->folder)));
		//check if the level exists and if it has the same number of levels
		if(!symptr || *(unsigned short*)(HeapDeref(symptr->handle)+2)!=(saveLevel->ll+saveStats->lvls-1))return FALSE;
		//mostly not nessisary but if it was archived or deleted the handle could be invalid
		(saveStats->lset).folder=symptr->handle;
	}
	return TRUE;
}

void drawStat(GAME *stats){
	char buff[20];
	FontSetSys (F_4x6);
  memset(LCD_MEM+PSEUDO_CONST_SCREEN(92*30,119*30),0xFF,20);
	sprintf(buff,"lvs %i",stats->lvs);
	DrawStr(90,PSEUDO_CONST_SCREEN(94,121),buff,A_REPLACE);
	sprintf(buff,"level# %i",stats->lvls);
	DrawStr(53,PSEUDO_CONST_SCREEN(94,121),buff,A_REPLACE);
	sprintf(buff,"score %i",stats->score);
	DrawStr(116,PSEUDO_CONST_SCREEN(94,121),buff,A_REPLACE);
	if(stats->shoot==1)
		Sprite8_OR_R(16,PSEUDO_CONST_SCREEN(94,121),4,pwu[4], LCD_MEM);
	if(stats->ebs<0)
		Sprite8_OR_R(3,PSEUDO_CONST_SCREEN(94,121),6,pwu[0], LCD_MEM);
	if(stats->ebs>0)
		Sprite8_OR_R(3,PSEUDO_CONST_SCREEN(94,122),6,&pwu[1][2], LCD_MEM);
	if(stats->ts!=0)
		Sprite8_OR_R(28,PSEUDO_CONST_SCREEN(95,122),6,&pwu[2][1], LCD_MEM);
	//if(?)
		//Sprite8_OR_R(40,PSEUDO_CONST_SCREEN(95,122),4,&pwu[5][4], LCD_MEM);
}
#ifndef SMALL
//========================main menu-big==============================
asm ("Mmenu:\n"
"        .word  title_text - Mmenu\n"
"        .word  0xD5\n"
"        .word  9\n"
"        .byte  0, 58\n"
"        .word  5\n"
"        .word  0\n"
"        .word  0\n"
"        .word  0\n"
"        .long  -1\n"
"      main_entries:\n"
"        .word  MT_TEXT + MT_CASCADE + 2\n"
"        .word  subMmenu_1_text - title_text\n"
"        .word  subMmenu_1_cascade - Mmenu\n"
"        .word  MT_TEXT + MT_CASCADE + 3\n"
"        .word  subMmenu_2_text - title_text\n"
"        .word  subMmenu_2_cascade - Mmenu\n"
"        .word  MT_TEXT + MT_CASCADE + 4\n"
"        .word  subMmenu_3_text - title_text\n"
"        .word  subMmenu_3_cascade - Mmenu\n"
"        .long  -1\n"
"      subMmenu_1_cascade:\n"
"        .word  MT_TEXT + 2\n"
"        .word  suboption_1_1_text - title_text\n"
"        .word  MT_TEXT + 1\n"
"        .word  suboption_1_2_text - title_text\n"
"        .long  -1\n"
"      subMmenu_2_cascade:\n"
"        .word  MT_TEXT + 3\n"
"        .word  suboption_2_1_text - title_text\n"
"        .word  MT_TEXT + 4\n"
"        .word  suboption_2_2_text - title_text\n"
"        .word  MT_TEXT + 7\n"
"        .word  suboption_2_3_text - title_text\n"
"        .long  -1\n"
"      subMmenu_3_cascade:\n"
"        .word  MT_TEXT + 5\n"
"        .word  suboption_3_1_text - title_text\n"
"        .word  MT_TEXT + 6\n"
"        .word  suboption_3_2_text - title_text\n"
"        .word  MT_TEXT + 8\n"
"        .word  suboption_3_3_text - title_text\n"
"        .long  -1\n"
"      title_text:\n"
#ifdef USE_VTI
"        .asciz \"Jpong "VERTION_STR" for VTI\"\n"
#else
"        .asciz \"Jpong "VERTION_STR"\"\n"
#endif
"      subMmenu_1_text:\n"
"        .asciz \"Play\"\n"
"      subMmenu_2_text:\n"
"        .asciz \"Help\"\n"
"      subMmenu_3_text:\n"
"        .asciz \"Scores\"\n"
"      suboption_1_1_text:\n"
"        .asciz \"Ext Level\"\n"
"      suboption_1_2_text:\n"
"        .asciz \"Int Level\"\n"
"      suboption_2_1_text:\n"
"        .asciz \"General\"\n"
"      suboption_2_2_text:\n"
"        .asciz \"Powerups\"\n"
"      suboption_2_3_text:\n"
"        .asciz \"Keys\"\n"
"      suboption_3_1_text:\n"
"        .asciz \"Veiw High Scores\"\n"
"      suboption_3_2_text:\n"
"        .asciz \"Reset High Scores\"\n"
"      suboption_3_3_text:\n"
"        .asciz \"Change Score List\"\n");
#else
//========================main menu-small==============================
asm ("Mmenu:\n"
"        .word  title_text - Mmenu\n"
"        .word  0xD5\n"
"        .word  9\n"
"        .byte  0, 58\n"
"        .word  5\n"
"        .word  0\n"
"        .word  0\n"
"        .word  0\n"
"        .long  -1\n"
"      main_entries:\n"
"        .word  MT_TEXT + MT_CASCADE + 2\n"
"        .word  subMmenu_1_text - title_text\n"
"        .word  subMmenu_1_cascade - Mmenu\n"
"        .word  MT_TEXT + 5\n"
"        .word  suboption_3_1_text - title_text\n"
"        .long  -1\n"
"      subMmenu_1_cascade:\n"
"        .word  MT_TEXT + 2\n"
"        .word  suboption_1_1_text - title_text\n"
"        .word  MT_TEXT + 1\n"
"        .word  suboption_1_2_text - title_text\n"
"        .long  -1\n"
"      title_text:\n"
#ifdef USE_VTI
"        .asciz \"Jpong "VERTION_STR" for VTI\"\n"
#else
"        .asciz \"Jpong "VERTION_STR"\"\n"
#endif
"      subMmenu_1_text:\n"
"        .asciz \"Play\"\n"
"      suboption_1_1_text:\n"
"        .asciz \"Ext Level\"\n"
"      suboption_1_2_text:\n"
"        .asciz \"Int Level\"\n"
"      suboption_3_1_text:\n"
"        .asciz \"Veiw High Scores\"");
#endif
